<?php

namespace App\Models;

use App\Http\Helpers\Hasher;

use Illuminate\Database\Eloquent\Model;
use Carbon\Carbon;

class Contract extends Model
{
    protected $table = 'contracts';

     protected $appends = ['hash_id', 'contract_obligation_list'];

    protected $hidden = [
        'id', 'in_time_contract_template',
    ];

    public function contract_obligation()
    {
        return $this->hasMany('App\Models\ContractObligation', 'contract_id');
    }

    public function getHashIdAttribute()
    {
        return Hasher::encode('contracts', $this->id);
    }

    public function getContractObligationListAttribute()
    {
        return $this->contract_obligation()->get()->makeHidden(['contract_list']);
    }

    public function getUpdatedAtAttribute($date) 
    {
        return $date ? Carbon::parse($date)->timezone('Asia/Kuala_Lumpur')->format('Y-m-d') : '';
    }

    public function getCreatedAtAttribute($date) 
    {
        return $date ? Carbon::parse($date)->timezone('Asia/Kuala_Lumpur')->format('Y-m-d') : '';
    }
}
